Option Explicit
' On Error Resume Next

'-------------------------------------------------------------------------
' PERF2RRD.vbs
'
' Beschreibung
' 
'  Musterprogramme, um Performancecounter in RRDTOOL-Datenbanken zu schreiben
' Voraussetzungen
' - Das Programm RRDTOOL muss sich im gleichen Verzeichnis befinden
' - Die RRD-Datenbank mssen Sie manuell vorher anlegen !
'     rrdtool CREATE ....  (Bitte RRD-Anleitung lesen
' - Laufzeitfehler werde nicht abgefangen und beenden das Skript.
' - Planen Sie den regelmigen Aufruf des Skripts mit dem Zeitplandienst ein
' - Rufen Sie das Cscript mit "CSCRIPT  scriptname" auf wegen DebugOutput
'
' Das Skript wird mit den Berechtigungen des angemeldeten Benutzers
' ausgefhrt. Die entsprechenden Berechtigungen sind sicher zu stellen
'
' (c)2004 Net at Work Netzwerksysteme GmbH
' 
' Version 1.0 (5. Aug 2004)
'		+ erste Version
'
'-------------------------------------------------------------------------

Const rrdtool = "c:\Programme\rrd\rrdtool.exe"  ' Pfad zu RRDTOOL
Const strserver="srv01"   ' Hier bitte ihren Server eintragen
dim CPUSet, DiskSet, MemorySet
dim cpu, disk, memory
dim wshShell, i, return

WScript.Echo WScript.ScriptName & " wurde gestartet."

WScript.Echo WScript.ScriptName & ": CPU-Belastung wird gelesen."
Set CPUSet = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" + strserver).ExecQuery("SELECT * FROM Win32_Processor")
i = 0
For Each cpu In CPUSet
  Update "cpu"+CStr(i)+".rrd", CStr(cpu.LoadPercentage)
  i = i + 1
Next

WScript.Echo WScript.ScriptName & ": Gre und freie Kapazitt der Festplatten werden gelesen."
i = 0
Set DiskSet = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" + strserver).ExecQuery("SELECT * FROM Win32_LogicalDisk WHERE DriveType=3")
For Each Disk In DiskSet
  Update "drive"+CStr(i)+"a.rrd", CStr(Disk.Size)
  Update "drive"+CStr(i)+"b.rrd", CStr(Disk.FreeSpace)
  i=i+1
Next

WScript.Echo WScript.ScriptName & ": Hauptspeicher Belastung wird gelesen."
i=0
Set memorySet = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" + strserver).ExecQuery("select * from Win32_LogicalMemoryConfiguration")
For Each memory In memorySet
  With memory
    Update "mem"+CStr(i)+".rrd", CStr(memory.TotalPageFileSpace) ' Zugesicherter Speicher (KB) Grenzwert 
    i=i+1
    Update "mem"+CStr(i)+".rrd", CStr(memory.TotalPhysicalMemory)  ' Physikalischer Speicher (KB) Insgesamt
    i=i+1
    Update "mem"+CStr(i)+".rrd", CStr(memory.TotalVirtualMemory)  ' Gesamter virtueller Speicher (KB)
    i=i+1
    Update "mem"+CStr(i)+".rrd", CStr(memory.AvailableVirtualMemory) ' Verfgbarer virtueller Speicher (KB)
    i=i+1    
  End With
Next

WScript.Echo WScript.ScriptName & ": Script beendet."
WScript.quit(0)


Function GetSecondFromDate()
  ' Gibt die Sekunden seit dem 1.1.1970 zurck (Unix Zeitstempel)
  GetSecondFromDate = DateDiff("s", CDate("01.01.1970"),Now)
End Function

Sub Update(DB, Wert)
  ' rrdtool update <DB-Name> <Zeitstempel>:<Wert>
  Set WshShell = WScript.CreateObject("WScript.Shell")
  Return = WshShell.Run(rrdtool &" update " & DB & " " & GetSecondFromDate & ":" & Wert, 0, True)
  MsgBox "rrdtool update " & DB & " " & GetSecondFromDate & ":" & Wert & " " & CStr(Return)
  Set WshShell = Nothing
End Sub